module Statistics  # ײϴطΥ롼

#---------------------------------------
#---------------------------------------

def self.interpo_search_1d( x, point, i_error=999, stdopt=false )
# ǿ뤴Ȥͤ礭ʤˤΤʤ,
# point ֹϤ.
#  implicit none
#  real, intent(in) :: x(:)  # 
#  real, intent(in) :: point  # 
#  integer, intent(inout) :: i  # point ͤۤʤֹͤ
#  integer, intent(in), optional :: undeff  # õϰϤǤ꾮ͤõ褦Ȥ, undef ֤,  undef ͤꤹ. default Ǥ 0.
#  logical, intent(in), optional :: stdopt  # õϰϤĤʤݤɸϤɽʤ褦ˤ.
#                                           # default Ǥ .false. (ɽ)
#  integer :: nx, j
#  integer :: just
#  logical :: stderr

  nx=x.length
  i_error=nx+1
  i=i_error

  for j in 0..nx-1
     if x[0]>point then
        if stdopt.eqv..false. then
           puts "****** WARNING ******"
           puts "searching point was not found :", x[0], point
           puts "Abort. Exit.###"
        end
        i=-1
        break
     end

     if x[j]<=point then
        i=j
     else
        break
     end
  end

  interpo_search_1d=i

  return interpo_search_1d

end

#------------------------------------
#---------------------------------------

def self.nearest_search_1d( x, point )
# 1 Ƕ˵õ롼
# interpo_search_1d ͤ, ͤ +1 ͤεΥӤ
# Υû򤹤.
#  implicit none
#  real, intent(in) :: x(:)  # 
#  real, intent(in) :: point  # 
#  integer, intent(inout) :: i  # point κǶ˵ֹ
#  real, intent(in), optional :: hx(size(x))  # x ɸΥ
#  real, intent(in), optional :: hp  # point ǤΥ ## ޤѰդ
#  real :: tmp1, tmp2
#  integer :: j, nx

  nx=x.length
  j=interpo_search_1d( x, point )

  if j==0 then  # i=1 ˤΤ, tmp1 x[1], tmp2  x[2] ,  if ʸ
           # Ǥޤ.
     tmp1=x[j]
     tmp2=x[j+1]
  else
     if j==nx-1 then  # i=nx ˤΤ, tmp2  x(nx), tmp1  x(nx-1) ,
            #  if ʸǤޤ.
        tmp1=x[j-1]
        tmp2=x[j-2]
     else
        tmp1=x[j-1]
        tmp2=x[j]
     end
  end

  if (point-tmp1).abs>(tmp2-point).abs then
     i=j
  else
     i=j-1
  end

  nearest_search_1d=i

  return nearest_search_1d

end

#---------------------------------------
#------------------------------------

def self.interpolation_1d( tmin, tmax, xmin, xmax, point, error=999.0 )
# 1 ޥ롼
#  implicit none
#  real, intent(in) :: x[2]  # κü
#  real, intent(in) :: y[2]  # x Ƥ
#  real, intent(in) :: point  # 
#  real, intent(inout) :: val  # Ǥ
#  real, intent(in), optional :: h[2]  # κǤΥ
#  real, intent(in), optional :: hp  # ǤΥ
#  real :: fd, dt
#  real :: tmin
#  real :: tmax
#  real :: xmin
#  real :: xmax

  dt=point-tmin

  fd=(xmax-xmin)/(tmax-tmin)

  val=xmin+dt*fd

  interpolation_1d=val

  return interpolation_1d

end


#------------------------------------
#------------------------------------

#---------------------------------
#---------------------------------
#---- ʲ, private 롼----
#---------------------------------
#---------------------------------


end
